<template>
  <b-card
    :title="data[card_title]"
    v-bind="card_options"
    img-top
    class="ac-simple-card"
    @mouseenter="$emit('hover', data)"
    @mousedown.stop="$emit('click', data)"
  >
    <!-- @slot Use this slot for card hover. Not shown if no hover slot -->
    <div
      class="card-wrapper"
    >
      <div class="card-hover">
        <slot name="hover"></slot>
      </div>

      <b-card-img
        :src="'https://picsum.photos/600/300/?image=25'"
        title="Card image"
      />
    </div>

    <!-- @slot Use this slot for card header. Not shown if no header slot -->
    <div
      slot="header"
      v-if="$slots.header"
      class="ac-simple-card__header"
    >
      <slot name="header"></slot>
    </div>

    <!-- Card text -->
    <b-card-text class="ac-simple-card__body">
      {{ data[card_text] }}
    </b-card-text>

    <!-- If prop bulk is true, then show checkbox -->
    <div
      v-show="bulk"
      class="ac-simple-card__checkbox"
    >
      <b-form-checkbox
        v-model="checkbox"
        :value="data.id"
        @change="$emit('input', data.id)"
      >
        Checkbox text
      </b-form-checkbox>
    </div>

    <!-- For each link inside a_href array create link button -->
    <div
      v-if="a_href.length"
      class="ac-simple-card__links my-2"
    >
      <b-button
        v-for="link in a_href"
        :key="link.href"
        :href="link.href"
        variant="primary"
        class="mr-1"
      >
        {{ link.label }}
      </b-button>

      <b-button
        v-if="is_delete"
        variant="danger"
        @click="on_delete_click"
      >
        Delete
      </b-button>
    </div>

    <!-- @slot Use this slot for card footer. Not shown if no footer slot -->
    <div
      slot="footer"
      v-if="$slots.footer"
      class="ac-simple-card__footer"
    >
      <slot name="footer"></slot>
    </div>
  </b-card>
</template>

<script>
/**
 * Simple Card component
 * @requires VueBootstrap
 */

export default {
  name: 'ac-simple-card',

  props: {
    /**
     * @param {object} data - Card data
     */
    data: {
      type: Object,
      required: true,
    },

    /**
     * @param {string} img - Key inside data prop, that contains image url
     */
    img: {
      type: String,
      required: true,
    },

    /**
     * @param {boolean} selected - is current card selected
     */
    selected: {
      type: Boolean,
      required: false,
      default: false,
    },

    /**
     * @param {string} card_title - Key inside data prop for title
     */
    card_title: {
      type: String,
      required: true,
    },

    /**
     * @param {string} card_text - Key inside data prop for text
     */
    card_text: {
      type: String,
      required: true,
    },

    /**
     * @param {boolean} bulk - Whenever true - show scheckbox
     */
    bulk: {
      type: Boolean,
      required: true,
    },

    /**
     * @param {array} a_href - Array of objects, that contains links.
     * Each object must contain
     * {string} title,
     * {string} href
     */
    a_href: {
      type: Array,
      required: true,
    },

    /**
     * @param {object} card_options - Object with vue bootstrap card options.
     */
    card_options: {
      type: Object,
      required: false,
      default: () => ({}),
    },

    is_delete: {
      type: Boolean,
      required: false,
      default: false,
    },
  },

  data() {
    return {
      checkbox: false,
    }
  },

  methods: {
    /**
     * Called in delete click
     * @function on_delete_click
     * @private
     */
    on_delete_click() {
      // eslint-disable-next-line no-restricted-globals
      if (confirm('delete ?')) {
        this.$emit('delete', this.data)
      }
    },
  },
}
</script>

<style scoped>
.ac-simple-card .card-wrapper {
  position: relative;
}

.ac-simple-card .card-hover {
  position: absolute;
  opacity: 0;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  transition: opacity .3s ease;
}

.ac-simple-card:hover .card-hover {
  opacity: 1;
}
</style>
